package com.itemis.jbc.ui.commands;

import com.google.inject.Inject;
import com.itemis.jbc.binary.ByteCodeWriter;
import com.itemis.jbc.jbc.ClassFile;
import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.resources.IContainer;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.core.runtime.Path;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.FileEditorInput;
import org.eclipse.xtext.parser.IParseResult;
import org.eclipse.xtext.parser.IParser;
import org.eclipse.xtext.xbase.lib.Exceptions;

@SuppressWarnings("all")
public class CreateClassFromJBCHandler extends AbstractHandler {
  @Inject
  private IParser parser;
  
  @Override
  public Object execute(final ExecutionEvent event) throws ExecutionException {
    try {
      IEditorPart _xblockexpression = null;
      {
        final IWorkbenchPage activePage = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
        ISelection selection = activePage.getSelection();
        IEditorPart _xifexpression = null;
        if ((selection instanceof IStructuredSelection)) {
          IEditorPart _xblockexpression_1 = null;
          {
            final Object element = ((IStructuredSelection)selection).getFirstElement();
            IEditorPart _xifexpression_1 = null;
            if ((element instanceof IFile)) {
              IEditorPart _xblockexpression_2 = null;
              {
                final IFile sourceFile = ((IFile) element);
                final String sourceName = sourceFile.getName();
                IEditorPart _xifexpression_2 = null;
                boolean _endsWith = sourceName.endsWith(".jbc");
                if (_endsWith) {
                  IEditorPart _xblockexpression_3 = null;
                  {
                    IContainer _parent = sourceFile.getParent();
                    int _length = sourceName.length();
                    int _minus = (_length - 4);
                    String _substring = sourceName.substring(0, _minus);
                    String _plus = (_substring + ".class");
                    Path _path = new Path(_plus);
                    final IFile targetFile = _parent.getFile(_path);
                    InputStreamReader reader = null;
                    IEditorPart _xtrycatchfinallyexpression = null;
                    try {
                      IEditorPart _xblockexpression_4 = null;
                      {
                        InputStream _contents = sourceFile.getContents();
                        InputStreamReader _inputStreamReader = new InputStreamReader(_contents);
                        reader = _inputStreamReader;
                        final IParseResult parseResult = this.parser.parse(reader);
                        EObject _semanticElement = parseResult.getRootNode().getSemanticElement();
                        final byte[] byteCode = ByteCodeWriter.writeClassFile(((ClassFile) _semanticElement));
                        boolean _exists = targetFile.exists();
                        if (_exists) {
                          ByteArrayInputStream _byteArrayInputStream = new ByteArrayInputStream(byteCode);
                          NullProgressMonitor _nullProgressMonitor = new NullProgressMonitor();
                          targetFile.setContents(_byteArrayInputStream, true, true, _nullProgressMonitor);
                        } else {
                          ByteArrayInputStream _byteArrayInputStream_1 = new ByteArrayInputStream(byteCode);
                          NullProgressMonitor _nullProgressMonitor_1 = new NullProgressMonitor();
                          targetFile.create(_byteArrayInputStream_1, true, _nullProgressMonitor_1);
                        }
                        FileEditorInput _fileEditorInput = new FileEditorInput(targetFile);
                        _xblockexpression_4 = activePage.openEditor(_fileEditorInput, "com.itemis.jbc.JBC");
                      }
                      _xtrycatchfinallyexpression = _xblockexpression_4;
                    } finally {
                      if ((reader != null)) {
                        reader.close();
                      }
                    }
                    _xblockexpression_3 = _xtrycatchfinallyexpression;
                  }
                  _xifexpression_2 = _xblockexpression_3;
                }
                _xblockexpression_2 = _xifexpression_2;
              }
              _xifexpression_1 = _xblockexpression_2;
            }
            _xblockexpression_1 = _xifexpression_1;
          }
          _xifexpression = _xblockexpression_1;
        }
        _xblockexpression = _xifexpression;
      }
      return _xblockexpression;
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
}
