package com.itemis.jbc.ui.commands;

import com.itemis.jbc.ui.custom.JBCInputStreamContentReader;
import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.resources.IContainer;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.core.runtime.Path;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.FileEditorInput;
import org.eclipse.xtext.util.StringInputStream;
import org.eclipse.xtext.xbase.lib.Exceptions;

@SuppressWarnings("all")
public class CreateJBCFromClassHandler extends AbstractHandler {
  @Override
  public Object execute(final ExecutionEvent event) throws ExecutionException {
    try {
      IEditorPart _xblockexpression = null;
      {
        final IWorkbenchPage activePage = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
        ISelection selection = activePage.getSelection();
        IEditorPart _xifexpression = null;
        if ((selection instanceof IStructuredSelection)) {
          IEditorPart _xblockexpression_1 = null;
          {
            final Object element = ((IStructuredSelection)selection).getFirstElement();
            IEditorPart _xifexpression_1 = null;
            if ((element instanceof IFile)) {
              IEditorPart _xblockexpression_2 = null;
              {
                final IFile sourceFile = ((IFile) element);
                final String sourceName = sourceFile.getName();
                IEditorPart _xifexpression_2 = null;
                boolean _endsWith = sourceName.endsWith(".class");
                if (_endsWith) {
                  IEditorPart _xblockexpression_3 = null;
                  {
                    IContainer _parent = sourceFile.getParent();
                    int _length = sourceName.length();
                    int _minus = (_length - 6);
                    String _substring = sourceName.substring(0, _minus);
                    String _plus = (_substring + ".jbc");
                    Path _path = new Path(_plus);
                    final IFile targetFile = _parent.getFile(_path);
                    final String content = new JBCInputStreamContentReader().readContent(sourceFile.getContents(), sourceFile.getCharset());
                    boolean _exists = targetFile.exists();
                    if (_exists) {
                      String _charset = sourceFile.getCharset();
                      StringInputStream _stringInputStream = new StringInputStream(content, _charset);
                      NullProgressMonitor _nullProgressMonitor = new NullProgressMonitor();
                      targetFile.setContents(_stringInputStream, true, true, _nullProgressMonitor);
                    } else {
                      String _charset_1 = sourceFile.getCharset();
                      StringInputStream _stringInputStream_1 = new StringInputStream(content, _charset_1);
                      NullProgressMonitor _nullProgressMonitor_1 = new NullProgressMonitor();
                      targetFile.create(_stringInputStream_1, true, _nullProgressMonitor_1);
                    }
                    FileEditorInput _fileEditorInput = new FileEditorInput(targetFile);
                    _xblockexpression_3 = activePage.openEditor(_fileEditorInput, "com.itemis.jbc.JBC");
                  }
                  _xifexpression_2 = _xblockexpression_3;
                }
                _xblockexpression_2 = _xifexpression_2;
              }
              _xifexpression_1 = _xblockexpression_2;
            }
            _xblockexpression_1 = _xifexpression_1;
          }
          _xifexpression = _xblockexpression_1;
        }
        _xblockexpression = _xifexpression;
      }
      return _xblockexpression;
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
}
