package com.itemis.jbc.ui.commands;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IResource;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.JavaCore;
import org.eclipse.jdt.internal.core.Region;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.part.FileEditorInput;
import org.eclipse.xtext.xbase.lib.Exceptions;

@SuppressWarnings("all")
public class OpenJBCFromJavaHandler extends AbstractHandler {
  @Override
  public Object execute(final ExecutionEvent event) throws ExecutionException {
    try {
      final IWorkbenchPage activePage = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
      ISelection selection = activePage.getSelection();
      if ((selection instanceof IStructuredSelection)) {
        final Object element = ((IStructuredSelection)selection).getFirstElement();
        if ((element instanceof ICompilationUnit)) {
          final Region region = new Region();
          region.add(((IJavaElement)element));
          IResource[] _generatedResources = JavaCore.getGeneratedResources(region, false);
          for (final IResource r : _generatedResources) {
            IWorkbenchPage _activePage = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
            FileEditorInput _fileEditorInput = new FileEditorInput(((IFile) r));
            _activePage.openEditor(_fileEditorInput, 
              "com.itemis.jbc.JBC");
          }
        }
      }
      return null;
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
}
