package com.itemis.jbc.ui.custom;

import com.itemis.jbc.ui.custom.IStorageHandler;
import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;
import org.eclipse.core.resources.IStorage;
import org.eclipse.ui.IFileEditorInput;

@SuppressWarnings("all")
class IFileEditorInputHandler implements InvocationHandler {
  private final IFileEditorInput original;
  
  public IFileEditorInputHandler(final IFileEditorInput original) {
    this.original = original;
  }
  
  @Override
  public Object invoke(final Object proxy, final Method method, final Object[] args) throws Throwable {
    boolean _equals = method.getName().equals("getStorage");
    if (_equals) {
      Object _invoke = method.invoke(this.original, args);
      return this.proxy(((IStorage) _invoke));
    } else {
      return method.invoke(this.original, args);
    }
  }
  
  private IStorage proxy(final IStorage storage) {
    ClassLoader _classLoader = this.getClass().getClassLoader();
    IStorageHandler _iStorageHandler = new IStorageHandler(storage);
    Object _newProxyInstance = Proxy.newProxyInstance(_classLoader, new Class[] { IStorage.class }, _iStorageHandler);
    return ((IStorage) _newProxyInstance);
  }
}
