package com.itemis.jbc.ui.custom;

import com.itemis.jbc.ui.custom.JBCInputStreamContentReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import org.eclipse.core.resources.IEncodedStorage;
import org.eclipse.core.resources.IStorage;
import org.eclipse.xtext.util.StringInputStream;

@SuppressWarnings("all")
class IStorageHandler implements InvocationHandler {
  private final IStorage original;
  
  public IStorageHandler(final IStorage original) {
    this.original = original;
  }
  
  @Override
  public Object invoke(final Object proxy, final Method method, final Object[] args) throws Throwable {
    if ((method.getName().equals("getContents") && (method.getParameterCount() == 0))) {
      InputStream _contents = this.original.getContents();
      final InputStreamReader reader = new InputStreamReader(_contents);
      try {
        final String content = new JBCInputStreamContentReader().readContent(this.original.getContents(), 
          ((IEncodedStorage) this.original).getCharset());
        return new StringInputStream(content);
      } finally {
        reader.close();
      }
    } else {
      return method.invoke(this.original, args);
    }
  }
}
