package com.itemis.jbc.ui.custom;

import com.itemis.jbc.binary.ByteCodeWriter;
import com.itemis.jbc.jbc.ClassFile;
import com.itemis.jbc.ui.custom.JBCInputStreamContentReader;
import java.io.ByteArrayInputStream;
import java.io.InputStream;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.jface.text.IDocument;
import org.eclipse.ui.IFileEditorInput;
import org.eclipse.xtext.resource.XtextResource;
import org.eclipse.xtext.ui.editor.model.XtextDocument;
import org.eclipse.xtext.ui.editor.model.XtextDocumentProvider;
import org.eclipse.xtext.util.concurrent.IUnitOfWork;

@SuppressWarnings("all")
public class JBCDocumentProvider extends XtextDocumentProvider {
  @Override
  protected void setDocumentContent(final IDocument document, final InputStream contentStream, final String encoding) throws CoreException {
    document.set(new JBCInputStreamContentReader().readContent(contentStream, encoding));
  }
  
  @Override
  protected void doSaveDocument(final IProgressMonitor monitor, final Object element, final IDocument document, final boolean overwrite) throws CoreException {
    if ((element instanceof IFileEditorInput)) {
      if ((document instanceof XtextDocument)) {
        if ((((IFileEditorInput)element).getFile().exists() && ((IFileEditorInput)element).getFile().getName().endsWith(".class"))) {
          ((XtextDocument)document).<Object>readOnly(new IUnitOfWork.Void<XtextResource>() {
            @Override
            public void process(final XtextResource resource) throws Exception {
              final EObject ast = resource.getParseResult().getRootASTElement();
              IFile _file = ((IFileEditorInput)element).getFile();
              byte[] _writeClassFile = ByteCodeWriter.writeClassFile(((ClassFile) ast));
              ByteArrayInputStream _byteArrayInputStream = new ByteArrayInputStream(_writeClassFile);
              _file.setContents(_byteArrayInputStream, true, true, monitor);
            }
          });
          return;
        }
      }
    }
    super.doSaveDocument(monitor, element, document, overwrite);
  }
}
