package com.itemis.jbc.ui.custom;

import com.itemis.jbc.binary.ByteCodeReader;
import com.itemis.jbc.generator.JBCCodeTemplates;
import com.itemis.jbc.jbc.ClassFile;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.List;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.ui.PlatformUI;
import org.eclipse.xtext.xbase.lib.Conversions;
import org.eclipse.xtext.xbase.lib.Exceptions;

@SuppressWarnings("all")
public class JBCInputStreamContentReader {
  private final static int DEFAULT_FILE_SIZE = (15 * 1024);
  
  public String readContent(final InputStream contentStream, final String encoding) throws CoreException {
    final byte[] content = this.readContent(contentStream);
    if ((((((((List<Byte>)Conversions.doWrapArray(content)).size() > 4) && (content[0] == (-54))) && (content[1] == (-2))) && (content[2] == (-70))) && 
      (content[3] == (-66)))) {
      return this.readContentFromClassFile(content);
    } else {
      return this.readContentFromTextFile(content, encoding);
    }
  }
  
  private byte[] readContent(final InputStream inputStream) {
    try {
      try {
        final ByteArrayOutputStream baos = new ByteArrayOutputStream();
        final DataOutputStream dos = new DataOutputStream(baos);
        final byte[] data = new byte[4096];
        int count = inputStream.read(data);
        while ((count != (-1))) {
          {
            dos.write(data, 0, count);
            count = inputStream.read(data);
          }
        }
        return baos.toByteArray();
      } catch (final Throwable _t) {
        if (_t instanceof IOException) {
          final IOException x = (IOException)_t;
          String message = null;
          String _message = x.getMessage();
          boolean _tripleNotEquals = (_message != null);
          if (_tripleNotEquals) {
            message = x.getMessage();
          } else {
            message = "";
          }
          final IStatus s = new Status(IStatus.ERROR, PlatformUI.PLUGIN_ID, IStatus.OK, message, x);
          throw new CoreException(s);
        } else {
          throw Exceptions.sneakyThrow(_t);
        }
      } finally {
        inputStream.close();
      }
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  private String readContentFromTextFile(final byte[] content, final String enc) {
    try {
      ByteArrayInputStream _byteArrayInputStream = new ByteArrayInputStream(content);
      InputStreamReader _inputStreamReader = new InputStreamReader(_byteArrayInputStream, enc);
      final BufferedReader in = new BufferedReader(_inputStreamReader, JBCInputStreamContentReader.DEFAULT_FILE_SIZE);
      try {
        final StringBuffer buffer = new StringBuffer(JBCInputStreamContentReader.DEFAULT_FILE_SIZE);
        final char[] readBuffer = new char[2048];
        int n = in.read(readBuffer);
        while ((n > 0)) {
          {
            buffer.append(readBuffer, 0, n);
            n = in.read(readBuffer);
          }
        }
        return buffer.toString();
      } catch (final Throwable _t) {
        if (_t instanceof IOException) {
          final IOException x = (IOException)_t;
          String message = null;
          String _message = x.getMessage();
          boolean _tripleNotEquals = (_message != null);
          if (_tripleNotEquals) {
            message = x.getMessage();
          } else {
            message = "";
          }
          final IStatus s = new Status(IStatus.ERROR, PlatformUI.PLUGIN_ID, IStatus.OK, message, x);
          throw new CoreException(s);
        } else {
          throw Exceptions.sneakyThrow(_t);
        }
      }
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  private String readContentFromClassFile(final byte[] content) {
    final ClassFile classFile = ByteCodeReader.fromByteArray(content);
    return JBCCodeTemplates.code(classFile);
  }
}
