package com.itemis.jbc.ui.highlight;

import com.itemis.jbc.ui.highlight.JBCHighlightingStyles;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.xtext.ui.editor.syntaxcoloring.DefaultHighlightingConfiguration;
import org.eclipse.xtext.ui.editor.syntaxcoloring.IHighlightingConfigurationAcceptor;
import org.eclipse.xtext.ui.editor.utils.TextStyle;

@SuppressWarnings("all")
public class JBCHighlightingConfiguration extends DefaultHighlightingConfiguration {
  public final static String CONSTANT_POOL_REFERENCE = JBCHighlightingStyles.CONSTANT_POOL_REFERENCE_ID;
  
  public final static String CODE_TABLE_REFERENCE = JBCHighlightingStyles.CODE_TABLE_REFERENCE_ID;
  
  @Override
  public void configure(final IHighlightingConfigurationAcceptor acceptor) {
    super.configure(acceptor);
    acceptor.acceptDefaultHighlighting(JBCHighlightingConfiguration.CONSTANT_POOL_REFERENCE, "Constant Pool Reference", 
      this.contantPoolReferenceTextStyle());
    acceptor.acceptDefaultHighlighting(JBCHighlightingConfiguration.CODE_TABLE_REFERENCE, "Code Table Reference", this.codeTableReferenceTextStyle());
  }
  
  @Override
  public TextStyle keywordTextStyle() {
    TextStyle textStyle = this.defaultTextStyle().copy();
    RGB _rGB = new RGB(127, 0, 85);
    textStyle.setColor(_rGB);
    textStyle.setStyle(SWT.BOLD);
    return textStyle;
  }
  
  @Override
  public TextStyle numberTextStyle() {
    TextStyle textStyle = this.defaultTextStyle().copy();
    RGB _rGB = new RGB(127, 127, 127);
    textStyle.setColor(_rGB);
    return textStyle;
  }
  
  @Override
  public TextStyle stringTextStyle() {
    TextStyle textStyle = this.defaultTextStyle().copy();
    RGB _rGB = new RGB(42, 0, 255);
    textStyle.setColor(_rGB);
    return textStyle;
  }
  
  private TextStyle contantPoolReferenceTextStyle() {
    TextStyle textStyle = this.defaultTextStyle().copy();
    RGB _rGB = new RGB(91, 42, 127);
    textStyle.setColor(_rGB);
    return textStyle;
  }
  
  private TextStyle codeTableReferenceTextStyle() {
    TextStyle textStyle = this.defaultTextStyle().copy();
    RGB _rGB = new RGB(91, 145, 42);
    textStyle.setColor(_rGB);
    return textStyle;
  }
}
