package com.itemis.jbc.ui.highlight;

import com.itemis.jbc.jbc.JbcPackage;
import com.itemis.jbc.ui.highlight.JBCHighlightingConfiguration;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.xtext.ide.editor.syntaxcoloring.DefaultSemanticHighlightingCalculator;
import org.eclipse.xtext.ide.editor.syntaxcoloring.IHighlightedPositionAcceptor;
import org.eclipse.xtext.util.CancelIndicator;

@SuppressWarnings("all")
public class JBCSemanticHighlightingCalculator extends DefaultSemanticHighlightingCalculator {
  @Override
  protected boolean highlightElement(final EObject object, final IHighlightedPositionAcceptor acceptor, final CancelIndicator cancelIndicator) {
    boolean _xblockexpression = false;
    {
      EList<EStructuralFeature> _eAllStructuralFeatures = object.eClass().getEAllStructuralFeatures();
      for (final EStructuralFeature feature : _eAllStructuralFeatures) {
        this.highlightFeature(acceptor, object, feature);
      }
      _xblockexpression = super.highlightElement(object, acceptor, cancelIndicator);
    }
    return _xblockexpression;
  }
  
  @Override
  protected void highlightFeature(final IHighlightedPositionAcceptor acceptor, final EObject object, final EStructuralFeature feature, final String... styleIds) {
    if ((feature instanceof EReference)) {
      boolean _isContainment = ((EReference)feature).isContainment();
      boolean _not = (!_isContainment);
      if (_not) {
        boolean _isSuperTypeOf = JbcPackage.eINSTANCE.getConstantPoolEntry().isSuperTypeOf(((EReference)feature).getEReferenceType());
        if (_isSuperTypeOf) {
          super.highlightFeature(acceptor, object, feature, JBCHighlightingConfiguration.CONSTANT_POOL_REFERENCE);
        } else {
          boolean _isSuperTypeOf_1 = JbcPackage.eINSTANCE.getCodeTableEntry().isSuperTypeOf(((EReference)feature).getEReferenceType());
          if (_isSuperTypeOf_1) {
            super.highlightFeature(acceptor, object, feature, JBCHighlightingConfiguration.CODE_TABLE_REFERENCE);
          }
        }
      }
    }
  }
}
