/**
 * generated by Xtext 2.11.0
 */
package com.itemis.jbc.ui.labeling;

import com.google.inject.Inject;
import com.itemis.jbc.binary.ClassFileAccessAPI;
import com.itemis.jbc.jbc.ClassFile;
import com.itemis.jbc.jbc.ConstantClass;
import com.itemis.jbc.jbc.ConstantDouble;
import com.itemis.jbc.jbc.ConstantFieldRef;
import com.itemis.jbc.jbc.ConstantFloat;
import com.itemis.jbc.jbc.ConstantInteger;
import com.itemis.jbc.jbc.ConstantInterfaceMethodRef;
import com.itemis.jbc.jbc.ConstantInvoceDynamic;
import com.itemis.jbc.jbc.ConstantLong;
import com.itemis.jbc.jbc.ConstantMethodHandle;
import com.itemis.jbc.jbc.ConstantMethodRef;
import com.itemis.jbc.jbc.ConstantMethodType;
import com.itemis.jbc.jbc.ConstantModule;
import com.itemis.jbc.jbc.ConstantNameAndType;
import com.itemis.jbc.jbc.ConstantPackage;
import com.itemis.jbc.jbc.ConstantString;
import com.itemis.jbc.jbc.ConstantUtf8;
import com.itemis.jbc.jbc.FieldInfo;
import com.itemis.jbc.jbc.Interface;
import com.itemis.jbc.jbc.Interfaces;
import com.itemis.jbc.jbc.JbcPackage;
import com.itemis.jbc.jbc.MethodInfo;
import com.itemis.jbc.jbc.U1;
import com.itemis.jbc.jbc.U2;
import com.itemis.jbc.jbc.U4;
import com.itemis.jbc.jbc.UString;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.edit.ui.provider.AdapterFactoryLabelProvider;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.jface.viewers.DelegatingStyledCellLabelProvider;
import org.eclipse.jface.viewers.StyledString;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.TextStyle;
import org.eclipse.swt.widgets.Display;
import org.eclipse.xtext.ui.editor.syntaxcoloring.IHighlightingConfiguration;
import org.eclipse.xtext.ui.label.AbstractLabelProvider;

/**
 * Provides labels for EObjects.
 * 
 * See https://www.eclipse.org/Xtext/documentation/304_ide_concepts.html#label-provider
 */
@SuppressWarnings("all")
public class JBCLabelProvider extends AbstractLabelProvider implements DelegatingStyledCellLabelProvider.IStyledLabelProvider {
  @Inject
  private IHighlightingConfiguration highlighting;
  
  private final static StyledString.Styler KEYWORD_STYLER = new StyledString.Styler() {
    @Override
    public void applyStyles(final TextStyle textStyle) {
      textStyle.foreground = Display.getDefault().getSystemColor(SWT.COLOR_DARK_MAGENTA);
      textStyle.font = JFaceResources.getFontRegistry().getBold(JFaceResources.DEFAULT_FONT);
    }
  };
  
  private final static StyledString.Styler KEYWORD_THIN_STYLER = new StyledString.Styler() {
    @Override
    public void applyStyles(final TextStyle textStyle) {
      textStyle.foreground = Display.getDefault().getSystemColor(SWT.COLOR_DARK_MAGENTA);
    }
  };
  
  private final static StyledString.Styler VALUE_STYLER = new StyledString.Styler() {
    @Override
    public void applyStyles(final TextStyle textStyle) {
      textStyle.foreground = Display.getDefault().getSystemColor(SWT.COLOR_BLUE);
    }
  };
  
  private final static StyledString.Styler STRING_STYLER = new StyledString.Styler() {
    @Override
    public void applyStyles(final TextStyle textStyle) {
      textStyle.foreground = Display.getDefault().getSystemColor(SWT.COLOR_DARK_BLUE);
    }
  };
  
  private final static StyledString.Styler GREY_STYLER = new StyledString.Styler() {
    @Override
    public void applyStyles(final TextStyle textStyle) {
      textStyle.foreground = Display.getDefault().getSystemColor(SWT.COLOR_GRAY);
    }
  };
  
  private final static StyledString.Styler GREY_DARK_STYLER = new StyledString.Styler() {
    @Override
    public void applyStyles(final TextStyle textStyle) {
      textStyle.foreground = Display.getDefault().getSystemColor(SWT.COLOR_DARK_GRAY);
    }
  };
  
  @Inject
  public JBCLabelProvider(final AdapterFactoryLabelProvider delegate) {
    super(delegate);
  }
  
  @Override
  public StyledString getStyledText(final Object element) {
    if ((element == null)) {
      return new StyledString();
    }
    if ((!(element instanceof EObject))) {
      String _string = element.toString();
      return new StyledString(_string);
    }
    boolean _matched = false;
    if (element instanceof ClassFile) {
      _matched=true;
      return this.styledText(((ClassFile)element));
    }
    if (!_matched) {
      if (element instanceof U1) {
        _matched=true;
        return this.styledText(((U1)element));
      }
    }
    if (!_matched) {
      if (element instanceof U2) {
        _matched=true;
        return this.styledText(((U2)element));
      }
    }
    if (!_matched) {
      if (element instanceof U4) {
        _matched=true;
        return this.styledText(((U4)element));
      }
    }
    if (!_matched) {
      if (element instanceof UString) {
        _matched=true;
        return this.styledText(((UString)element));
      }
    }
    if (!_matched) {
      if (element instanceof ConstantUtf8) {
        _matched=true;
        return this.styledText(((ConstantUtf8)element));
      }
    }
    if (!_matched) {
      if (element instanceof ConstantClass) {
        _matched=true;
        return this.styledText(((ConstantClass)element));
      }
    }
    if (!_matched) {
      if (element instanceof ConstantNameAndType) {
        _matched=true;
        return this.styledText(((ConstantNameAndType)element));
      }
    }
    if (!_matched) {
      if (element instanceof ConstantFieldRef) {
        _matched=true;
        return this.styledText(((ConstantFieldRef)element));
      }
    }
    if (!_matched) {
      if (element instanceof ConstantMethodRef) {
        _matched=true;
        return this.styledText(((ConstantMethodRef)element));
      }
    }
    if (!_matched) {
      if (element instanceof ConstantInterfaceMethodRef) {
        _matched=true;
        return this.styledText(((ConstantInterfaceMethodRef)element));
      }
    }
    if (!_matched) {
      if (element instanceof ConstantInteger) {
        _matched=true;
        return this.styledText(((ConstantInteger)element));
      }
    }
    if (!_matched) {
      if (element instanceof ConstantFloat) {
        _matched=true;
        return this.styledText(((ConstantFloat)element));
      }
    }
    if (!_matched) {
      if (element instanceof ConstantLong) {
        _matched=true;
        return this.styledText(((ConstantLong)element));
      }
    }
    if (!_matched) {
      if (element instanceof ConstantDouble) {
        _matched=true;
        return this.styledText(((ConstantDouble)element));
      }
    }
    if (!_matched) {
      if (element instanceof ConstantString) {
        _matched=true;
        return this.styledText(((ConstantString)element));
      }
    }
    if (!_matched) {
      if (element instanceof ConstantMethodHandle) {
        _matched=true;
        return this.styledText(((ConstantMethodHandle)element));
      }
    }
    if (!_matched) {
      if (element instanceof ConstantMethodType) {
        _matched=true;
        return this.styledText(((ConstantMethodType)element));
      }
    }
    if (!_matched) {
      if (element instanceof ConstantInvoceDynamic) {
        _matched=true;
        return this.styledText(((ConstantInvoceDynamic)element));
      }
    }
    if (!_matched) {
      if (element instanceof ConstantModule) {
        _matched=true;
        return this.styledText(((ConstantModule)element));
      }
    }
    if (!_matched) {
      if (element instanceof ConstantPackage) {
        _matched=true;
        return this.styledText(((ConstantPackage)element));
      }
    }
    if (!_matched) {
      if (element instanceof MethodInfo) {
        _matched=true;
        return this.styledText(((MethodInfo)element));
      }
    }
    if (!_matched) {
      if (element instanceof FieldInfo) {
        _matched=true;
        return this.styledText(((FieldInfo)element));
      }
    }
    return this.styledText(((EObject) element));
  }
  
  private StyledString styledText(final ClassFile classFile) {
    final StyledString result = new StyledString();
    boolean _isPublic = ClassFileAccessAPI.isPublic(classFile);
    if (_isPublic) {
      this.add(result, "public ", JBCLabelProvider.KEYWORD_STYLER);
    }
    boolean _isFinal = ClassFileAccessAPI.isFinal(classFile);
    if (_isFinal) {
      this.add(result, "final ", JBCLabelProvider.KEYWORD_STYLER);
    }
    boolean _isSuper = ClassFileAccessAPI.isSuper(classFile);
    if (_isSuper) {
      this.add(result, "super ", JBCLabelProvider.KEYWORD_STYLER);
    }
    boolean _isAbstract = ClassFileAccessAPI.isAbstract(classFile);
    if (_isAbstract) {
      this.add(result, "abstract ", JBCLabelProvider.KEYWORD_STYLER);
    }
    boolean _isSynthetic = ClassFileAccessAPI.isSynthetic(classFile);
    if (_isSynthetic) {
      this.add(result, "synthetic ", JBCLabelProvider.KEYWORD_STYLER);
    }
    boolean _isClass = ClassFileAccessAPI.isClass(classFile);
    if (_isClass) {
      this.add(result, "class ", JBCLabelProvider.KEYWORD_STYLER);
    }
    boolean _isInterface = ClassFileAccessAPI.isInterface(classFile);
    if (_isInterface) {
      this.add(result, "interface ", JBCLabelProvider.KEYWORD_STYLER);
    }
    boolean _isEnum = ClassFileAccessAPI.isEnum(classFile);
    if (_isEnum) {
      this.add(result, "enum ", JBCLabelProvider.KEYWORD_STYLER);
    }
    boolean _isAnnotation = ClassFileAccessAPI.isAnnotation(classFile);
    if (_isAnnotation) {
      this.add(result, "annotation ", JBCLabelProvider.KEYWORD_STYLER);
    }
    ConstantClass _thisClass = null;
    if (classFile!=null) {
      _thisClass=classFile.getThisClass();
    }
    ConstantUtf8 _nameIndex = null;
    if (_thisClass!=null) {
      _nameIndex=_thisClass.getNameIndex();
    }
    UString _content = null;
    if (_nameIndex!=null) {
      _content=_nameIndex.getContent();
    }
    String _value = null;
    if (_content!=null) {
      _value=_content.getValue();
    }
    StyledString _add = this.add(this.add(result, _value), " extends ", JBCLabelProvider.KEYWORD_STYLER);
    ConstantClass _superClass = null;
    if (classFile!=null) {
      _superClass=classFile.getSuperClass();
    }
    ConstantUtf8 _nameIndex_1 = null;
    if (_superClass!=null) {
      _nameIndex_1=_superClass.getNameIndex();
    }
    UString _content_1 = null;
    if (_nameIndex_1!=null) {
      _content_1=_nameIndex_1.getContent();
    }
    String _value_1 = null;
    if (_content_1!=null) {
      _value_1=_content_1.getValue();
    }
    this.add(_add, _value_1);
    Interfaces _interfaces = null;
    if (classFile!=null) {
      _interfaces=classFile.getInterfaces();
    }
    EList<Interface> _interfaceInfo = null;
    if (_interfaces!=null) {
      _interfaceInfo=_interfaces.getInterfaceInfo();
    }
    int _size = 0;
    if (_interfaceInfo!=null) {
      _size=_interfaceInfo.size();
    }
    boolean _greaterThan = (_size > 0);
    if (_greaterThan) {
      this.add(result, " implements ", JBCLabelProvider.KEYWORD_STYLER);
      String seperator = "";
      Interfaces _interfaces_1 = null;
      if (classFile!=null) {
        _interfaces_1=classFile.getInterfaces();
      }
      EList<Interface> _interfaceInfo_1 = _interfaces_1.getInterfaceInfo();
      for (final Interface i : _interfaceInfo_1) {
        {
          ConstantClass _info = null;
          if (i!=null) {
            _info=i.getInfo();
          }
          ConstantUtf8 _nameIndex_2 = null;
          if (_info!=null) {
            _nameIndex_2=_info.getNameIndex();
          }
          UString _content_2 = null;
          if (_nameIndex_2!=null) {
            _content_2=_nameIndex_2.getContent();
          }
          String _value_2 = _content_2.getValue();
          String _plus = (seperator + _value_2);
          this.add(result, _plus);
          seperator = ", ";
        }
      }
    }
    U2 _majorVersion = null;
    if (classFile!=null) {
      _majorVersion=classFile.getMajorVersion();
    }
    int _intValue = 0;
    if (_majorVersion!=null) {
      _intValue=ClassFileAccessAPI.intValue(_majorVersion);
    }
    String _plus = (" (" + Integer.valueOf(_intValue));
    String _plus_1 = (_plus + ".");
    U2 _minorVersion = classFile.getMinorVersion();
    int _intValue_1 = 0;
    if (_minorVersion!=null) {
      _intValue_1=ClassFileAccessAPI.intValue(_minorVersion);
    }
    String _plus_2 = (_plus_1 + Integer.valueOf(_intValue_1));
    String _plus_3 = (_plus_2 + ")");
    this.add(result, _plus_3, 
      JBCLabelProvider.GREY_DARK_STYLER);
    return result;
  }
  
  @Override
  public String getText(final Object element) {
    return this.getStyledText(element).toString();
  }
  
  private StyledString styledText(final U1 u1) {
    String _value = u1.getValue();
    return new StyledString(_value, JBCLabelProvider.VALUE_STYLER);
  }
  
  private StyledString styledText(final U2 u2) {
    String _value = u2.getValue();
    return new StyledString(_value, JBCLabelProvider.VALUE_STYLER);
  }
  
  private StyledString styledText(final U4 u4) {
    String _value = u4.getValue();
    return new StyledString(_value, JBCLabelProvider.VALUE_STYLER);
  }
  
  private StyledString styledText(final UString uString) {
    String _value = uString.getValue();
    return new StyledString(_value, JBCLabelProvider.VALUE_STYLER);
  }
  
  private StyledString styledText(final ConstantClass constant) {
    StyledString _styledString = new StyledString("class ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    ConstantUtf8 _nameIndex = null;
    if (constant!=null) {
      _nameIndex=constant.getNameIndex();
    }
    UString _content = null;
    if (_nameIndex!=null) {
      _content=_nameIndex.getContent();
    }
    String _value = null;
    if (_content!=null) {
      _value=_content.getValue();
    }
    return this.add(_styledString, _value);
  }
  
  private StyledString styledText(final ConstantNameAndType constant) {
    StyledString _styledString = new StyledString("nameAndType ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    ConstantUtf8 _descriptorIndex = null;
    if (constant!=null) {
      _descriptorIndex=constant.getDescriptorIndex();
    }
    UString _content = null;
    if (_descriptorIndex!=null) {
      _content=_descriptorIndex.getContent();
    }
    String _value = null;
    if (_content!=null) {
      _value=_content.getValue();
    }
    StyledString _add = this.add(this.add(_styledString, _value), "#");
    ConstantUtf8 _nameIndex = null;
    if (constant!=null) {
      _nameIndex=constant.getNameIndex();
    }
    UString _content_1 = null;
    if (_nameIndex!=null) {
      _content_1=_nameIndex.getContent();
    }
    String _value_1 = null;
    if (_content_1!=null) {
      _value_1=_content_1.getValue();
    }
    return this.add(_add, _value_1);
  }
  
  private StyledString styledText(final ConstantUtf8 constant) {
    StyledString _styledString = new StyledString("utf8 ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    UString _content = null;
    if (constant!=null) {
      _content=constant.getContent();
    }
    String _value = null;
    if (_content!=null) {
      _value=_content.getValue();
    }
    return this.add(_styledString, _value, JBCLabelProvider.STRING_STYLER);
  }
  
  private StyledString styledText(final ConstantFieldRef constant) {
    StyledString _styledString = new StyledString("fieldRef ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    ConstantClass _classIndex = null;
    if (constant!=null) {
      _classIndex=constant.getClassIndex();
    }
    ConstantUtf8 _nameIndex = null;
    if (_classIndex!=null) {
      _nameIndex=_classIndex.getNameIndex();
    }
    UString _content = null;
    if (_nameIndex!=null) {
      _content=_nameIndex.getContent();
    }
    String _value = null;
    if (_content!=null) {
      _value=_content.getValue();
    }
    StyledString _add = this.add(this.add(_styledString, _value, 
      JBCLabelProvider.GREY_DARK_STYLER), "#", JBCLabelProvider.GREY_DARK_STYLER);
    ConstantNameAndType _nameAndTypeIndex = null;
    if (constant!=null) {
      _nameAndTypeIndex=constant.getNameAndTypeIndex();
    }
    ConstantUtf8 _nameIndex_1 = null;
    if (_nameAndTypeIndex!=null) {
      _nameIndex_1=_nameAndTypeIndex.getNameIndex();
    }
    UString _content_1 = null;
    if (_nameIndex_1!=null) {
      _content_1=_nameIndex_1.getContent();
    }
    String _value_1 = null;
    if (_content_1!=null) {
      _value_1=_content_1.getValue();
    }
    StyledString _add_1 = this.add(this.add(_add, _value_1), 
      " ");
    ConstantNameAndType _nameAndTypeIndex_1 = null;
    if (constant!=null) {
      _nameAndTypeIndex_1=constant.getNameAndTypeIndex();
    }
    ConstantUtf8 _descriptorIndex = null;
    if (_nameAndTypeIndex_1!=null) {
      _descriptorIndex=_nameAndTypeIndex_1.getDescriptorIndex();
    }
    UString _content_2 = null;
    if (_descriptorIndex!=null) {
      _content_2=_descriptorIndex.getContent();
    }
    String _value_2 = null;
    if (_content_2!=null) {
      _value_2=_content_2.getValue();
    }
    return this.add(_add_1, _value_2, JBCLabelProvider.GREY_STYLER);
  }
  
  private StyledString styledText(final ConstantMethodRef constant) {
    StyledString _styledString = new StyledString("methodRef ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    ConstantClass _classIndex = null;
    if (constant!=null) {
      _classIndex=constant.getClassIndex();
    }
    ConstantUtf8 _nameIndex = null;
    if (_classIndex!=null) {
      _nameIndex=_classIndex.getNameIndex();
    }
    UString _content = null;
    if (_nameIndex!=null) {
      _content=_nameIndex.getContent();
    }
    String _value = null;
    if (_content!=null) {
      _value=_content.getValue();
    }
    StyledString _add = this.add(this.add(_styledString, _value, 
      JBCLabelProvider.GREY_DARK_STYLER), "#", JBCLabelProvider.GREY_DARK_STYLER);
    ConstantNameAndType _nameAndTypeIndex = null;
    if (constant!=null) {
      _nameAndTypeIndex=constant.getNameAndTypeIndex();
    }
    ConstantUtf8 _nameIndex_1 = null;
    if (_nameAndTypeIndex!=null) {
      _nameIndex_1=_nameAndTypeIndex.getNameIndex();
    }
    UString _content_1 = null;
    if (_nameIndex_1!=null) {
      _content_1=_nameIndex_1.getContent();
    }
    String _value_1 = null;
    if (_content_1!=null) {
      _value_1=_content_1.getValue();
    }
    StyledString _add_1 = this.add(this.add(_add, _value_1), 
      " ");
    ConstantNameAndType _nameAndTypeIndex_1 = null;
    if (constant!=null) {
      _nameAndTypeIndex_1=constant.getNameAndTypeIndex();
    }
    ConstantUtf8 _descriptorIndex = null;
    if (_nameAndTypeIndex_1!=null) {
      _descriptorIndex=_nameAndTypeIndex_1.getDescriptorIndex();
    }
    UString _content_2 = null;
    if (_descriptorIndex!=null) {
      _content_2=_descriptorIndex.getContent();
    }
    String _value_2 = null;
    if (_content_2!=null) {
      _value_2=_content_2.getValue();
    }
    return this.add(_add_1, _value_2, JBCLabelProvider.GREY_STYLER);
  }
  
  private StyledString styledText(final ConstantInterfaceMethodRef constant) {
    StyledString _styledString = new StyledString("interfaceMethodRef ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    ConstantClass _classIndex = null;
    if (constant!=null) {
      _classIndex=constant.getClassIndex();
    }
    ConstantUtf8 _nameIndex = null;
    if (_classIndex!=null) {
      _nameIndex=_classIndex.getNameIndex();
    }
    UString _content = null;
    if (_nameIndex!=null) {
      _content=_nameIndex.getContent();
    }
    String _value = null;
    if (_content!=null) {
      _value=_content.getValue();
    }
    StyledString _add = this.add(this.add(_styledString, _value, JBCLabelProvider.GREY_DARK_STYLER), "#", JBCLabelProvider.GREY_DARK_STYLER);
    ConstantNameAndType _nameAndTypeIndex = null;
    if (constant!=null) {
      _nameAndTypeIndex=constant.getNameAndTypeIndex();
    }
    ConstantUtf8 _nameIndex_1 = null;
    if (_nameAndTypeIndex!=null) {
      _nameIndex_1=_nameAndTypeIndex.getNameIndex();
    }
    UString _content_1 = null;
    if (_nameIndex_1!=null) {
      _content_1=_nameIndex_1.getContent();
    }
    String _value_1 = null;
    if (_content_1!=null) {
      _value_1=_content_1.getValue();
    }
    StyledString _add_1 = this.add(this.add(_add, _value_1), " ");
    ConstantNameAndType _nameAndTypeIndex_1 = null;
    if (constant!=null) {
      _nameAndTypeIndex_1=constant.getNameAndTypeIndex();
    }
    ConstantUtf8 _descriptorIndex = null;
    if (_nameAndTypeIndex_1!=null) {
      _descriptorIndex=_nameAndTypeIndex_1.getDescriptorIndex();
    }
    UString _content_2 = null;
    if (_descriptorIndex!=null) {
      _content_2=_descriptorIndex.getContent();
    }
    String _value_2 = null;
    if (_content_2!=null) {
      _value_2=_content_2.getValue();
    }
    return this.add(_add_1, _value_2, JBCLabelProvider.GREY_STYLER);
  }
  
  private StyledString styledText(final ConstantInteger constantInteger) {
    return this.add(new StyledString("int ", JBCLabelProvider.KEYWORD_THIN_STYLER), Integer.toString(ClassFileAccessAPI.getIntValue(constantInteger)), JBCLabelProvider.VALUE_STYLER);
  }
  
  private StyledString styledText(final ConstantFloat constantFloat) {
    return this.add(new StyledString("float ", JBCLabelProvider.KEYWORD_THIN_STYLER), Float.toString(ClassFileAccessAPI.getFloatValue(constantFloat)), JBCLabelProvider.VALUE_STYLER);
  }
  
  private StyledString styledText(final ConstantLong constantFloat) {
    return this.add(new StyledString("long ", JBCLabelProvider.KEYWORD_THIN_STYLER), Long.toString(ClassFileAccessAPI.getLongValue(constantFloat)), JBCLabelProvider.VALUE_STYLER);
  }
  
  private StyledString styledText(final ConstantDouble constantDouble) {
    return this.add(new StyledString("double ", JBCLabelProvider.KEYWORD_THIN_STYLER), Double.toString(ClassFileAccessAPI.getDoubleValue(constantDouble)), JBCLabelProvider.VALUE_STYLER);
  }
  
  private StyledString styledText(final ConstantString constantString) {
    StyledString _styledString = new StyledString("string ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    ConstantUtf8 _stringIndex = null;
    if (constantString!=null) {
      _stringIndex=constantString.getStringIndex();
    }
    UString _content = null;
    if (_stringIndex!=null) {
      _content=_stringIndex.getContent();
    }
    String _value = null;
    if (_content!=null) {
      _value=_content.getValue();
    }
    String _plus = ("\"" + _value);
    String _plus_1 = (_plus + "\"");
    return this.add(_styledString, _plus_1, 
      JBCLabelProvider.VALUE_STYLER);
  }
  
  private StyledString styledText(final ConstantMethodHandle constant) {
    return this.add(this.add(this.add(new StyledString("methodHandle ", JBCLabelProvider.KEYWORD_THIN_STYLER), Integer.toString(ClassFileAccessAPI.intValue(constant.getReferenceKind()))), " "), this.styledText(constant.getReferenceIndex()));
  }
  
  private StyledString styledText(final ConstantMethodType constant) {
    return this.add(new StyledString("methodType ", JBCLabelProvider.KEYWORD_THIN_STYLER), constant.getDescriptorIndex().getContent().getValue());
  }
  
  private StyledString styledText(final ConstantInvoceDynamic constant) {
    StyledString _add = this.add(this.add(new StyledString("methodInvokeDynamic ", JBCLabelProvider.KEYWORD_THIN_STYLER), 
      Integer.toString(ClassFileAccessAPI.intValue(constant.getBootstrapMethodAttrIndex()))), " ");
    ConstantNameAndType _nameAndTypeIndex = null;
    if (constant!=null) {
      _nameAndTypeIndex=constant.getNameAndTypeIndex();
    }
    ConstantUtf8 _nameIndex = null;
    if (_nameAndTypeIndex!=null) {
      _nameIndex=_nameAndTypeIndex.getNameIndex();
    }
    UString _content = null;
    if (_nameIndex!=null) {
      _content=_nameIndex.getContent();
    }
    String _value = null;
    if (_content!=null) {
      _value=_content.getValue();
    }
    StyledString _add_1 = this.add(this.add(_add, _value), " ");
    ConstantNameAndType _nameAndTypeIndex_1 = null;
    if (constant!=null) {
      _nameAndTypeIndex_1=constant.getNameAndTypeIndex();
    }
    ConstantUtf8 _descriptorIndex = null;
    if (_nameAndTypeIndex_1!=null) {
      _descriptorIndex=_nameAndTypeIndex_1.getDescriptorIndex();
    }
    UString _content_1 = null;
    if (_descriptorIndex!=null) {
      _content_1=_descriptorIndex.getContent();
    }
    String _value_1 = null;
    if (_content_1!=null) {
      _value_1=_content_1.getValue();
    }
    return this.add(_add_1, _value_1, JBCLabelProvider.GREY_STYLER);
  }
  
  private StyledString styledText(final ConstantModule constant) {
    return this.add(new StyledString("module ", JBCLabelProvider.KEYWORD_THIN_STYLER), constant.getNameIndex().getContent().getValue());
  }
  
  private StyledString styledText(final ConstantPackage constant) {
    return this.add(new StyledString("package ", JBCLabelProvider.KEYWORD_THIN_STYLER), constant.getNameIndex().getContent().getValue());
  }
  
  private StyledString styledText(final FieldInfo field) {
    final StyledString result = new StyledString();
    boolean _isFinal = ClassFileAccessAPI.isFinal(field);
    if (_isFinal) {
      this.add(result, "final ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isStatic = ClassFileAccessAPI.isStatic(field);
    if (_isStatic) {
      this.add(result, "static ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isPublic = ClassFileAccessAPI.isPublic(field);
    if (_isPublic) {
      this.add(result, "public ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isPrivate = ClassFileAccessAPI.isPrivate(field);
    if (_isPrivate) {
      this.add(result, "private ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isProtected = ClassFileAccessAPI.isProtected(field);
    if (_isProtected) {
      this.add(result, "protected ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isPackageProtected = ClassFileAccessAPI.isPackageProtected(field);
    if (_isPackageProtected) {
      this.add(result, "package ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isVolatile = ClassFileAccessAPI.isVolatile(field);
    if (_isVolatile) {
      this.add(result, "volatile ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isTransient = ClassFileAccessAPI.isTransient(field);
    if (_isTransient) {
      this.add(result, "transient ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isSynthetic = ClassFileAccessAPI.isSynthetic(field);
    if (_isSynthetic) {
      this.add(result, "synthetic ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isEnum = ClassFileAccessAPI.isEnum(field);
    if (_isEnum) {
      this.add(result, "enum ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    ConstantUtf8 _nameIndex = null;
    if (field!=null) {
      _nameIndex=field.getNameIndex();
    }
    UString _content = null;
    if (_nameIndex!=null) {
      _content=_nameIndex.getContent();
    }
    StyledString _add = this.add(this.add(result, _content.getValue()), " ");
    ConstantUtf8 _descriptorIndex = null;
    if (field!=null) {
      _descriptorIndex=field.getDescriptorIndex();
    }
    UString _content_1 = null;
    if (_descriptorIndex!=null) {
      _content_1=_descriptorIndex.getContent();
    }
    String _value = null;
    if (_content_1!=null) {
      _value=_content_1.getValue();
    }
    this.add(_add, _value, JBCLabelProvider.GREY_STYLER);
    return result;
  }
  
  private StyledString styledText(final MethodInfo method) {
    final StyledString result = new StyledString();
    boolean _isFinal = ClassFileAccessAPI.isFinal(method);
    if (_isFinal) {
      this.add(result, "final ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isAbstract = ClassFileAccessAPI.isAbstract(method);
    if (_isAbstract) {
      this.add(result, "abstract ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isNative = ClassFileAccessAPI.isNative(method);
    if (_isNative) {
      this.add(result, "native ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isStatic = ClassFileAccessAPI.isStatic(method);
    if (_isStatic) {
      this.add(result, "static ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isPublic = ClassFileAccessAPI.isPublic(method);
    if (_isPublic) {
      this.add(result, "public ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isPrivate = ClassFileAccessAPI.isPrivate(method);
    if (_isPrivate) {
      this.add(result, "private ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isProtected = ClassFileAccessAPI.isProtected(method);
    if (_isProtected) {
      this.add(result, "protected ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isPackageProtected = ClassFileAccessAPI.isPackageProtected(method);
    if (_isPackageProtected) {
      this.add(result, "package ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isSynchronized = ClassFileAccessAPI.isSynchronized(method);
    if (_isSynchronized) {
      this.add(result, "synchronized ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isBridge = ClassFileAccessAPI.isBridge(method);
    if (_isBridge) {
      this.add(result, "bridge ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isVarargs = ClassFileAccessAPI.isVarargs(method);
    if (_isVarargs) {
      this.add(result, "varargs ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isStrict = ClassFileAccessAPI.isStrict(method);
    if (_isStrict) {
      this.add(result, "strict ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    boolean _isSynthetic = ClassFileAccessAPI.isSynthetic(method);
    if (_isSynthetic) {
      this.add(result, "synthetic ", JBCLabelProvider.KEYWORD_THIN_STYLER);
    }
    ConstantUtf8 _nameIndex = null;
    if (method!=null) {
      _nameIndex=method.getNameIndex();
    }
    UString _content = null;
    if (_nameIndex!=null) {
      _content=_nameIndex.getContent();
    }
    StyledString _add = this.add(this.add(result, _content.getValue()), " ");
    ConstantUtf8 _descriptorIndex = null;
    if (method!=null) {
      _descriptorIndex=method.getDescriptorIndex();
    }
    UString _content_1 = null;
    if (_descriptorIndex!=null) {
      _content_1=_descriptorIndex.getContent();
    }
    String _value = null;
    if (_content_1!=null) {
      _value=_content_1.getValue();
    }
    this.add(_add, _value, JBCLabelProvider.GREY_STYLER);
    return result;
  }
  
  private StyledString styledText(final EObject eObject) {
    String _name = eObject.eClass().getName();
    final StyledString result = new StyledString(_name, JBCLabelProvider.KEYWORD_THIN_STYLER);
    String seperator = " ";
    EList<EStructuralFeature> _eAllStructuralFeatures = eObject.eClass().getEAllStructuralFeatures();
    for (final EStructuralFeature feature : _eAllStructuralFeatures) {
      if ((((feature != JbcPackage.eINSTANCE.getCodeTableEntry_Tag()) && 
        (feature != JbcPackage.eINSTANCE.getAttributeInfo_AttributeNameIndex())) && 
        (feature != JbcPackage.eINSTANCE.getAttributeInfo_AttributeLength()))) {
        if ((feature instanceof EReference)) {
          boolean _isContainment = ((EReference)feature).isContainment();
          if (_isContainment) {
            final Object child = eObject.eGet(feature);
            if ((child instanceof U1)) {
              String _value = ((U1)child).getValue();
              String _plus = (seperator + _value);
              this.add(result, _plus, JBCLabelProvider.GREY_DARK_STYLER);
              seperator = ", ";
            } else {
              if ((child instanceof U2)) {
                String _value_1 = ((U2)child).getValue();
                String _plus_1 = (seperator + _value_1);
                this.add(result, _plus_1, JBCLabelProvider.GREY_DARK_STYLER);
                seperator = ", ";
              } else {
                if ((child instanceof U4)) {
                  String _value_2 = ((U4)child).getValue();
                  String _plus_2 = (seperator + _value_2);
                  this.add(result, _plus_2, JBCLabelProvider.GREY_DARK_STYLER);
                  seperator = ", ";
                }
              }
            }
          } else {
            final Object reference = eObject.eGet(feature);
            this.add(this.add(result, seperator), this.getStyledText(reference));
            seperator = ", ";
          }
        }
      }
    }
    return result;
  }
  
  private StyledString add(final StyledString input, final String string) {
    if ((string == null)) {
      return input;
    }
    return input.append(string);
  }
  
  private StyledString add(final StyledString input, final String string, final StyledString.Styler styler) {
    if ((string == null)) {
      return input;
    }
    return input.append(string, styler);
  }
  
  private StyledString add(final StyledString input, final StyledString next) {
    if ((next == null)) {
      return input;
    }
    return input.append(next);
  }
}
